Package org.eclipse.m2m.atl.engine.vm.nativelib

# Class ASMTransientLink

java.lang.Object
org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject
org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny
org.eclipse.m2m.atl.engine.vm.nativelib.ASMTransientLink

public class ASMTransientLink extends ASMOclAny
An ASMTransientLink represents an internal traceability link. Other languages than ATL may be compiled to ATL VM and reuse this class. They can also define their own traceability links using Maps and Tuples.

## Field Summary

Fields
Modifier and Type
Field
Description
`static ASMOclType`
`myType`

### Fields inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject

`nativeImpl`

## Constructor Summary

Constructors
Constructor
Description
`ASMTransientLink()`

## Method Summary

Modifier and Type
Method
Description
`static void`
`addSourceElement(StackFrame frame, ASMTransientLink self, ASMString name, ASMOclAny element)`
`static void`
`addTargetElement(StackFrame frame, ASMTransientLink self, ASMString name, ASMOclAny element)`
`static void`
`addVariable(StackFrame frame, ASMTransientLink self, ASMString name, ASMOclAny value)`
`static ASMOclAny`
`getNamedTargetFromSource(StackFrame frame, ASMTransientLink self, ASMOclAny sourceElement, ASMString name)`
`static ASMOclAny`
`getRule(StackFrame frame, ASMTransientLink self)`
`static ASMOclAny`
`getSourceElement(StackFrame frame, ASMTransientLink self, ASMString name)`
`Collection`
`getSourceElements()`
`static ASMMap`
`getSourceElements(StackFrame frame, ASMTransientLink self)`
This method allows for retrieving all source elements for this link without knowing the local variable names of the rule that created the mappings.
`Map`
`getSourceMap()`
`static ASMOclAny`
`getTargetElement(StackFrame frame, ASMTransientLink self, ASMString name)`
`Collection`
`getTargetElements()`
`static ASMMap`
`getTargetElements(StackFrame frame, ASMTransientLink self)`
This method allows for retrieving all target elements for this link without knowing the local variable names of the rule that created the mappings.
`static ASMOclAny`
`getTargetFromSource(StackFrame frame, ASMTransientLink self, ASMOclAny sourceElement)`
`static ASMOclAny`
`getVariable(StackFrame frame, ASMTransientLink self, ASMString name)`
`static void`
`setRule(StackFrame frame, ASMTransientLink self, ASMOclAny rule)`
`String`
`toString()`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny

`asBag, asSequence, asSet, check, debug, findOperation, findOperation, get, getHelper, getNamedTargetFromSource, getOclAnyType, getType, invoke, invoke, invokeSuper, isHelper, oclIsKindOf, oclIsTypeOf, oclIsUndefined, oclType, operatorEQ, operatorNE, output, refGetValue, refImmediateComposite, refImmediateComposite, refInvokeOperation, refSetValue, refUnsetValue, set, setType, toString, unset`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject

`getNativeImpl`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### myType

public static ASMOclType myType

## Constructor Details

### ASMTransientLink

public ASMTransientLink()

## Method Details

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### getSourceMap

public Map getSourceMap()

### getSourceElements

public Collection getSourceElements()

### getTargetElements

public Collection getTargetElements()

### setRule

public static void setRule(StackFrame frame, ASMTransientLink self, ASMOclAny rule)

### addSourceElement

public static void addSourceElement(StackFrame frame, ASMTransientLink self, ASMString name, ASMOclAny element)

### addTargetElement

public static void addTargetElement(StackFrame frame, ASMTransientLink self, ASMString name, ASMOclAny element)

### addVariable

public static void addVariable(StackFrame frame, ASMTransientLink self, ASMString name, ASMOclAny value)

### getRule

public static ASMOclAny getRule(StackFrame frame, ASMTransientLink self)

### getSourceElement

public static ASMOclAny getSourceElement(StackFrame frame, ASMTransientLink self, ASMString name)

### getTargetElement

public static ASMOclAny getTargetElement(StackFrame frame, ASMTransientLink self, ASMString name)

### getTargetFromSource

public static ASMOclAny getTargetFromSource(StackFrame frame, ASMTransientLink self, ASMOclAny sourceElement)

### getNamedTargetFromSource

public static ASMOclAny getNamedTargetFromSource(StackFrame frame, ASMTransientLink self, ASMOclAny sourceElement, ASMString name)

### getVariable

public static ASMOclAny getVariable(StackFrame frame, ASMTransientLink self, ASMString name)

### getSourceElements

public static ASMMap getSourceElements(StackFrame frame, ASMTransientLink self)
This method allows for retrieving all source elements for this link without knowing the local variable names of the rule that created the mappings. This reduces fragility.

Parameters:
  `frame` -
  `self` -
Returns:
  A Map of source element names to target elements for this link.

### getTargetElements

public static ASMMap getTargetElements(StackFrame frame, ASMTransientLink self)
This method allows for retrieving all target elements for this link without knowing the local variable names of the rule that created the mappings. This reduces fragility.

Parameters:
  `frame` -
  `self` -
Returns:
  A Map of target element names to target elements for this link.